/*
 * Intel ACPI Component Architecture
 * AML/ASL+ Disassembler version 20160108-64
 * Copyright (c) 2000 - 2016 Intel Corporation
 * 
 * Disassembling to symbolic ASL+ operators
 *
 * Disassembly of ssdt2.dat, Fri Nov  4 02:20:03 2016
 *
 * Original Table Header:
 *     Signature        "SSDT"
 *     Length           0x0000076F (1903)
 *     Revision         0x01
 *     Checksum         0x17
 *     OEM ID           "LENOVO"
 *     OEM Table ID     "Cpu0Ist"
 *     OEM Revision     0x00003000 (12288)
 *     Compiler ID      "INTL"
 *     Compiler Version 0x20120711 (538052369)
 */
DefinitionBlock ("ssdt2.aml", "SSDT", 1, "LENOVO", "Cpu0Ist", 0x00003000)
{

    External (_PR_.CPU0, DeviceObj)
    External (_SB_.PCI0.LPC_.EC__.AC__._PSR, UnknownObj)
    External (_SB_.PCI0.LPC_.EC__.LPMD, IntObj)
    External (_SB_.PCI0.LPC_.EC__.PIBS, IntObj)
    External (_SB_.PCI0.LPC_.EC__.PLLS, UnknownObj)
    External (_SB_.PCI0.LPC_.EC__.PLMS, UnknownObj)
    External (_SB_.PCI0.LPC_.EC__.PLSL, UnknownObj)
    External (_SB_.PCI0.LPC_.EC__.PLTU, UnknownObj)
    External (_SB_.PCI0.LPC_.EC__.TSL0, UnknownObj)
    External (CFGD, UnknownObj)
    External (FTPS, IntObj)
    External (GFPL, IntObj)
    External (LWST, IntObj)
    External (MTAU, IntObj)
    External (PDC0, UnknownObj)
    External (PL1L, IntObj)
    External (PL1M, IntObj)
    External (PPCA, IntObj)
    External (PPCR, UnknownObj)
    External (TCFA, UnknownObj)
    External (TCFD, UnknownObj)
    External (TCNT, IntObj)

    Scope (\_PR.CPU0)
    {
        Method (_PPC, 0, NotSerialized)  // _PPC: Performance Present Capabilities
        {
            Local0 = Zero
            Local0 = \_SB.PCI0.LPC.EC.LPMD /* External reference */
            If (!Local0)
            {
                If (((\_SB.PCI0.LPC.EC.AC._PSR && \TCFA) || (!\_SB.PCI0.LPC.EC.AC._PSR && \TCFD)))
                {
                    If ((\_SB.PCI0.LPC.EC.TSL0 & 0x76))
                    {
                        Local0 = \LWST /* External reference */
                    }
                }
                ElseIf ((\_SB.PCI0.LPC.EC.TSL0 & 0x77))
                {
                    Local0 = \LWST /* External reference */
                }

                If (!Local0)
                {
                    If ((\PPCA || \FTPS))
                    {
                        If ((\FTPS <= \PPCA))
                        {
                            Local0 = \PPCA /* External reference */
                        }
                        Else
                        {
                            Local0 = \FTPS /* External reference */
                        }
                    }
                }
            }

            If (((\GFPL && !Local0) || (!\GFPL && Local0)))
            {
                Local1 = 0x03E8
                While (\_SB.PCI0.LPC.EC.PIBS)
                {
                    Sleep (One)
                    Local1--
                    If (!Local1)
                    {
                        \PPCR = Local0
                        Return (Local0)
                    }
                }

                If (Local0)
                {
                    If (!\GFPL)
                    {
                        \GFPL = One
                        \_SB.PCI0.LPC.EC.PLSL = 0x04
                        \_SB.PCI0.LPC.EC.PLTU = One
                        \_SB.PCI0.LPC.EC.PLLS = 0x0D
                        \_SB.PCI0.LPC.EC.PLMS = Zero
                    }
                }
                ElseIf (\GFPL)
                {
                    \GFPL = Zero
                    \_SB.PCI0.LPC.EC.PLSL = 0x04
                    If (\MTAU)
                    {
                        \_SB.PCI0.LPC.EC.PLTU = \MTAU /* External reference */
                    }
                    Else
                    {
                        \_SB.PCI0.LPC.EC.PLTU = 0x1C
                    }

                    \_SB.PCI0.LPC.EC.PLLS = \PL1L /* External reference */
                    \_SB.PCI0.LPC.EC.PLMS = \PL1M /* External reference */
                }
            }

            \PPCR = Local0
            Return (Local0)
        }

        Method (_PCT, 0, NotSerialized)  // _PCT: Performance Control
        {
            If (((CFGD & One) && (PDC0 & One)))
            {
                Return (Package (0x02)
                {
                    ResourceTemplate ()
                    {
                        Register (FFixedHW, 
                            0x00,               // Bit Width
                            0x00,               // Bit Offset
                            0x0000000000000000, // Address
                            ,)
                    }, 

                    ResourceTemplate ()
                    {
                        Register (FFixedHW, 
                            0x00,               // Bit Width
                            0x00,               // Bit Offset
                            0x0000000000000000, // Address
                            ,)
                    }
                })
            }
        }

        Name (_PSS, Package (0x10)  // _PSS: Performance Supported States
        {
            Package (0x06)
            {
                0x00000A8D, 
                0x0000B798, 
                0x0000000A, 
                0x0000000A, 
                0x00002900, 
                0x00002900
            }, 

            Package (0x06)
            {
                0x00000A8C, 
                0x0000B798, 
                0x0000000A, 
                0x0000000A, 
                0x00001B00, 
                0x00001B00
            }, 

            Package (0x06)
            {
                0x00000A28, 
                0x0000AE3F, 
                0x0000000A, 
                0x0000000A, 
                0x00001A00, 
                0x00001A00
            }, 

            Package (0x06)
            {
                0x00000960, 
                0x00009C15, 
                0x0000000A, 
                0x0000000A, 
                0x00001800, 
                0x00001800
            }, 

            Package (0x06)
            {
                0x000008FC, 
                0x00009505, 
                0x0000000A, 
                0x0000000A, 
                0x00001700, 
                0x00001700
            }, 

            Package (0x06)
            {
                0x00000898, 
                0x00008C5A, 
                0x0000000A, 
                0x0000000A, 
                0x00001600, 
                0x00001600
            }, 

            Package (0x06)
            {
                0x000007D0, 
                0x00007D42, 
                0x0000000A, 
                0x0000000A, 
                0x00001400, 
                0x00001400
            }, 

            Package (0x06)
            {
                0x0000076C, 
                0x00007516, 
                0x0000000A, 
                0x0000000A, 
                0x00001300, 
                0x00001300
            }, 

            Package (0x06)
            {
                0x000006A4, 
                0x0000653E, 
                0x0000000A, 
                0x0000000A, 
                0x00001100, 
                0x00001100
            }, 

            Package (0x06)
            {
                0x00000640, 
                0x00005F34, 
                0x0000000A, 
                0x0000000A, 
                0x00001000, 
                0x00001000
            }, 

            Package (0x06)
            {
                0x000005DC, 
                0x000057AC, 
                0x0000000A, 
                0x0000000A, 
                0x00000F00, 
                0x00000F00
            }, 

            Package (0x06)
            {
                0x00000514, 
                0x00004AA7, 
                0x0000000A, 
                0x0000000A, 
                0x00000D00, 
                0x00000D00
            }, 

            Package (0x06)
            {
                0x000004B0, 
                0x00004396, 
                0x0000000A, 
                0x0000000A, 
                0x00000C00, 
                0x00000C00
            }, 

            Package (0x06)
            {
                0x0000044C, 
                0x00003CAE, 
                0x0000000A, 
                0x0000000A, 
                0x00000B00, 
                0x00000B00
            }, 

            Package (0x06)
            {
                0x00000384, 
                0x000030D2, 
                0x0000000A, 
                0x0000000A, 
                0x00000900, 
                0x00000900
            }, 

            Package (0x06)
            {
                0x00000320, 
                0x00002A5C, 
                0x0000000A, 
                0x0000000A, 
                0x00000800, 
                0x00000800
            }
        })
        Package (0x06)
        {
            0x80000000, 
            0x80000000, 
            0x80000000, 
            0x80000000, 
            0x80000000, 
            0x80000000
        }

        Package (0x06)
        {
            0x80000000, 
            0x80000000, 
            0x80000000, 
            0x80000000, 
            0x80000000, 
            0x80000000
        }

        Package (0x06)
        {
            0x80000000, 
            0x80000000, 
            0x80000000, 
            0x80000000, 
            0x80000000, 
            0x80000000
        }

        Package (0x06)
        {
            0x80000000, 
            0x80000000, 
            0x80000000, 
            0x80000000, 
            0x80000000, 
            0x80000000
        }

        Package (0x06)
        {
            0x80000000, 
            0x80000000, 
            0x80000000, 
            0x80000000, 
            0x80000000, 
            0x80000000
        }

        Package (0x06)
        {
            0x80000000, 
            0x80000000, 
            0x80000000, 
            0x80000000, 
            0x80000000, 
            0x80000000
        }

        Package (0x06)
        {
            0x80000000, 
            0x80000000, 
            0x80000000, 
            0x80000000, 
            0x80000000, 
            0x80000000
        }

        Package (0x06)
        {
            0x80000000, 
            0x80000000, 
            0x80000000, 
            0x80000000, 
            0x80000000, 
            0x80000000
        }

        Package (0x06)
        {
            0x80000000, 
            0x80000000, 
            0x80000000, 
            0x80000000, 
            0x80000000, 
            0x80000000
        }

        Package (0x06)
        {
            0x80000000, 
            0x80000000, 
            0x80000000, 
            0x80000000, 
            0x80000000, 
            0x80000000
        }

        Package (0x06)
        {
            0x80000000, 
            0x80000000, 
            0x80000000, 
            0x80000000, 
            0x80000000, 
            0x80000000
        }

        Package (0x06)
        {
            0x80000000, 
            0x80000000, 
            0x80000000, 
            0x80000000, 
            0x80000000, 
            0x80000000
        }

        Package (0x06)
        {
            0x80000000, 
            0x80000000, 
            0x80000000, 
            0x80000000, 
            0x80000000, 
            0x80000000
        }

        Package (0x06)
        {
            0x80000000, 
            0x80000000, 
            0x80000000, 
            0x80000000, 
            0x80000000, 
            0x80000000
        }

        Package (0x06)
        {
            0x80000000, 
            0x80000000, 
            0x80000000, 
            0x80000000, 
            0x80000000, 
            0x80000000
        }

        Package (0x06)
        {
            0x80000000, 
            0x80000000, 
            0x80000000, 
            0x80000000, 
            0x80000000, 
            0x80000000
        }

        Name (PSDF, Zero)
        Method (_PSD, 0, NotSerialized)  // _PSD: Power State Dependencies
        {
            If (!PSDF)
            {
                DerefOf (HPSD [Zero]) [0x04] = TCNT /* External reference */
                DerefOf (SPSD [Zero]) [0x04] = TCNT /* External reference */
                PSDF = Ones
            }

            If ((PDC0 & 0x0800))
            {
                Return (HPSD) /* \_PR_.CPU0.HPSD */
            }

            Return (SPSD) /* \_PR_.CPU0.SPSD */
        }

        Name (HPSD, Package (0x01)
        {
            Package (0x05)
            {
                0x05, 
                Zero, 
                Zero, 
                0xFE, 
                0x80
            }
        })
        Name (SPSD, Package (0x01)
        {
            Package (0x05)
            {
                0x05, 
                Zero, 
                Zero, 
                0xFC, 
                0x80
            }
        })
    }
}

